#include <sys/time.h>
#include <unistd.h>

#include <stdio.h>
#include <math.h>

double f( double );
double f( double a )
{
    return (4.0 / (1.0 + a*a));
}

int main( int argc, char *argv[])
{
    int done = 0, n, myid, numprocs, i;
    double PI25DT = 3.141592653589793238462643;
    double pi, h, sum, x;
    double startwtime = 0.0, endwtime;
    int  namelen;

    struct timeval _ttime;
    struct timezone _tzone;


    n=100000000; 

    gettimeofday(&_ttime, &_tzone);
    startwtime = (double)_ttime.tv_sec + (double)_ttime.tv_usec/1000000.;

    h   = 1.0 / (double) n;
    printf("Step length is %lg\n",h);
    sum = 0.0;
    for (i = 1; i <= n; i += 1)
    {
        x = h * ((double)i - 0.5);
//        printf("X is %lg\n",x);

//        sum += f(x);
        sum += (4.0 / (1.0 + x*x));
    }
    printf("Partial sum is %lg\n",sum);
    pi = h * sum;

    printf("pi is approximately %.16f, Error is %.16f\n",
           pi, fabs(pi - PI25DT));
    gettimeofday(&_ttime, &_tzone);
    endwtime = (double)_ttime.tv_sec + (double)_ttime.tv_usec/1000000.;
    printf("wall clock time = %f\n",
		       (endwtime-startwtime));	       
    return 0;
}

            
