/*
 * mc.c
 *  
 *  Created on: Sep 27, 2017
 *  Author: Wim R.M. Cardoen
 */

#include <stdio.h>
#include <gsl/gsl_rng.h>
#include <integ.h>

/*
 * Calc. a Definite Integral using a Monte Carlo method
 */
double MCInteg(double a, double b, long int N,
               double (*f)(double))
{
    long int i;
    double x, res, DX;
    DX = b-a;

    gsl_rng *r;
    const gsl_rng_type * T;

    gsl_rng_env_setup();

    T = gsl_rng_default;
    r = gsl_rng_alloc (T);

    /*
       printf("\n  Generator type:'%s'\n",gsl_rng_name(r));
       printf("  Seed:'%lu'\n", gsl_rng_default_seed);
    */

    res = 0.0;
    for(i=1; i<=N; i++)
    {
        x = a + DX*gsl_rng_uniform(r);
        res += f(x); 
    }
  
    res = res*DX/((double)N);
    return res;
}

