/*
 * trap.c
 * 
 * Created on: Sep 27, 2017
 * Author: Wim R.M. Cardoen
 */


#include <integ.h>

/* 
 *  Calc. a Definite Integral using the Trapezoid Rule
 */
double TrapInteg(double a, double b, long int N,
            double (*f)(double))
{
    long int i;
    double dx=(b-a)/((double)N);
    double res=0.0;
    for(i=0; i<N; i++)
        res+= 2.0*f(a+i*dx);
    return (res+f(b)-f(a))*dx/2.0;
}

