/*
 * functions.c
 *  
 *  Created on: Sep 27, 2017
 *  Author: Wim R.M. Cardoen
 */

#include <math.h>
#include <function.h>


/* Test functions that will be used 
 * for integration
 *   f1 := 4./(1.0+x**2)
 *   f2 := exp(x)
 *   f3 := 1.0/(1.0 + sinh(2x)*log(x)^2
 */

double f1(double x)
{
    return 4.0/(1+x*x);
}

double f2(double x)
{
    return exp(x);
}

double f3(double x)
{
    double lx = log(x);
    double denom = 1.0+sinh(2*x)*lx*lx;
    return 1.0/denom;
}
