/*
 *  main.c
 *  
 *   Created on: Sep 27, 2017
 *   Author: Wim R.M. Cardoen
 */
#include <stdio.h>
#include <math.h>
#include <integ.h>
#include <function.h>

int main(void)
{
    int i;
    int const SZ=3;
    long int Ninter[3]={100000,1000000,10000000};
    double res1, res2, res3;

    printf("Monte Carlo & Trapezoid Integration::\n");
    for(i=0; i<SZ; i++)
    {
        printf("\n#Iterations:%ld\n",Ninter[i]);
        printf("  Monte-Carlo Integration::\n");
        res1 = MCInteg(0.0,1.0,Ninter[i],f1);
        res2 = MCInteg(0.0,1.0,Ninter[i],f2);
        res3 = MCInteg(0.8,3.0,Ninter[i],f3);
        printf("    Integ1:%14.10lf  Exact:%14.10lf  dx=%14.10lf\n",res1,PI,fabs(res1-PI));
        printf("    Integ2:%14.10lf  Exact:%14.10lf  dx=%14.10lf\n",res2,EULER,fabs(res2-EULER));
        printf("    Integ3:%14.10lf  Exact:%14.10lf  dx=%14.10lf\n",res3,WOLFRAM,fabs(res3-WOLFRAM));

        printf("  Trapezoid Integration::\n");
        res1 = TrapInteg(0.0,1.0,Ninter[i],f1);
        res2 = TrapInteg(0.0,1.0,Ninter[i],f2);
        res3 = TrapInteg(0.8,3.0,Ninter[i],f3);
        printf("    Integ1:%14.10lf  Exact:%14.10lf  dx=%14.10lf\n",res1,PI,fabs(res1-PI));
        printf("    Integ2:%14.10lf  Exact:%14.10lf  dx=%14.10lf\n",res2,EULER,fabs(res2-EULER));
        printf("    Integ3:%14.10lf  Exact:%14.10lf  dx=%14.10lf\n",res3,WOLFRAM,fabs(res3-WOLFRAM));
    }
    return 0;
}
